var nS = {

	user: "",
	settingsObj: null,
	containerSliderWrapper : null,
	containerSlider : null,
	tW : 100,
	tH : 100,
	itemInfo : new Array(),
	
	
	//Initiate : function(elementID, userid, album, maxWidth, nivoOptions, theme) {
	Initiate : function(elementID, params, nivoOptions, theme, instance) {
		if( params.maxWidth !== undefined ) { jQuery('#'+elementID).css('max-width',params.maxWidth); }
		nS.containerSliderWrapper =jQuery('<div class="slider-wrapper theme-'+theme+'"></div>').appendTo('#'+elementID);

		sliderID='slider'+instance;
		
		nS.containerSlider =jQuery('<div id="'+sliderID+'" class="nivoSlider"></div>').appendTo(nS.containerSliderWrapper);

		var nOpt;
		try {
			nOpt = jQuery.parseJSON(nivoOptions);
			nOpt.afterChange = function(){
				//alert('after:' + jQuery('#'+sliderID + ' .nivo-slice img').attr('src'));
				//alert("hello");
				//nS.animate('#'+sliderID + ' .nivo-main-image',500);
				//nS.animate('#'+sliderID + ' .nivo-slice img',1000);
			};
			nOpt.beforeChange = function(){
				//alert('before:'+jQuery('#'+sliderID + ' .nivo-slice img').attr('src'));
			};
		} catch (err) {
			var txt="There is an error in the NIVO OPTIONS section : please check the settings.\n\n";
			txt+="Error description: " + err.message + "\n\n";
			txt+="Defined options:\n\n "+nivoOptions+"\n\n";
			alert(txt);
		}

		switch(params.kind) {
			case "url":
				var items=params.listImages.split('|');
				for (var i = 0; i < items.length; i++) {
					jQuery('<img src="'+params.listImagesBaseURL+items[i]+'" alt=""></img>').appendTo('#'+sliderID);
				}
				jQuery('#'+sliderID).nivoSlider(nOpt);
				break;
			case "picasa":
				nS.GetPicasaImages(params.userID, params.albumName,sliderID,nOpt, params.displayCaption);
				//jQuery('<img src="http://lh3.ggpht.com/-4jvb2UXP-vE/UTiECBU3KMI/AAAAAAAAAH8/-j8hzeyRviM/s1600/DSC_3224_resize.jpg" alt=""></img>').appendTo(nS.containerSlider);
				//jQuery('<img src="http://lh3.ggpht.com/-kuzYFhXooCo/UTiECVzZtsI/AAAAAAAAAH0/X7ZVGXACSlw/s1600/_DSC0059.jpg" alt=""></img>').appendTo(nS.containerSlider);
				//jQuery('<img src="http://lh3.ggpht.com/-JuLS2WMPTVs/UTiECb3pLJI/AAAAAAAAAH4/XOvu9PR0hTc/s1600/_DSC0066.jpg" alt=""></img>').appendTo(nS.containerSlider);
				break;
		}
	
		
//		var t;
//		nS.test({"userID2":"hello"});
	},

	animate : function ( item, dur ) {
	//alert(parseInt(jQuery(item).css('height')));
		var obj = {
			width: parseInt(jQuery(item).css('width'))*1.1,	//1126,		//102
			height: parseInt(jQuery(item).css('height'))*1.1 //381			//34
		};
		//obj.marginTop=0;
		//obj.marginLeft=0;
		//obj.width=1024;
		//obj.height=347;
		switch( Math.ceil( Math.random() * 2 ) ) {
			case 1:
				obj.marginTop = -10;
				break;
			case 2:
				obj.marginTop = -parseInt(jQuery(item).css('height')) *0.1 //-34 //-120
				break;
		}
		switch( Math.ceil( Math.random() * 2 ) ) {
			case 1:
				obj.marginLeft = -30;
				break;
			case 2:
				obj.marginLeft = -parseInt(jQuery(item).css('width')) *0.1 //-102 //-200
				break;
		}
		jQuery(item).animate(obj, dur, 'swing' );			//linear
	},
	
	
	
	test : function(t) {
		if( t.userID != null) {
			alert(t.userID);
		}
	},

	
	GetPicasaImages : function(userID, albumName,sliderID,nOpt, displayCaption) {
		var url = 'http://picasaweb.google.com/data/feed/api/user/'+userID+'/albumid/'+albumName+'?alt=json&kind=photo&imgmax=1600';
		jQuery.ajaxSetup({ cache: false });
		jQuery.getJSON(url, function(data) {
			
			jQuery.each(data.feed.entry, function(i,data){
				//Get the title  (=filename)
				itemTitle = data.media$group.media$title.$t;
				//Get the URL of the thumbnail
				//itemThumbURL = data.media$group.media$thumbnail[0].url;
				//Get the ID 
				itemID = data.id.$t;
				itemID = itemID.split('/')[9].split('?')[0];
				//Get the description
				itemDescription = data.media$group.media$description.$t;
				imgUrl=data.media$group.media$content[0].url;
				var capt="";
				if( displayCaption == true ) { capt=itemDescription; }
				var nImg=jQuery('<img src="'+imgUrl+'" alt="" title="'+capt+'"></img>').appendTo('#'+sliderID);
			});
			jQuery('#'+sliderID).nivoSlider(nOpt);
		})
		//.success(function() { alert("second success"); 	})
		.error( function(XMLHttpRequest, textStatus, errorThrown) {
			alert("Cannot retrieve Picasa/Google+ images (URL:"+url+") : " + XMLHttpRequest.responseText); 
		});
		//.complete(function() { alert("complete"); });

	},


	
	GetItems : function ( itemID, albumLabel ) {
		$(nS.containerFolder).children().remove();

		if( itemID == '' ) {
			var url = 'http://picasaweb.google.com/data/feed/api/user/'+nS.user+'?alt=json&kind=album&thumbsize='+nS.thumbSize;
			kind='album';
		}
		else {
			var url = 'http://picasaweb.google.com/data/feed/api/user/'+nS.user+'/albumid/'+itemID+'?alt=json&kind=photo&thumbsize='+nS.thumbSize+'&imgmax=1600';
			kind='photo';
		}

		// breadcrumb
		if( albumLabel != "" ) {
			if( jQuery(nS.containerBreadcrumb).children().length > 0 ) {
				jQuery('<div class="separator">&nbsp;>&nbsp;</div>').appendTo(nS.containerBreadcrumb);
			}
			var newDiv =jQuery('<div class="folder">'+albumLabel+'</div>').appendTo(nS.containerBreadcrumb);
			jQuery(newDiv).data("path",itemID);
			newDiv.click(function() {
				var folder=$(this).data("path");
				jQuery(this).nextAll().remove();
				nS.GetItems(folder,'');
			});;
		}

		
		
		// get the content and display it
		jQuery.ajaxSetup({ cache: false });
		jQuery.getJSON(url, function(data) {
			nS.settingsObj = data;
			
			jQuery.each(data.feed.entry, function(i,data){
				//Get the title 
				itemTitle = data.media$group.media$title.$t;
				//Get the URL of the thumbnail
				itemThumbURL = data.media$group.media$thumbnail[0].url;
				//Get the ID 
				itemID = data.id.$t;
				itemID = itemID.split('/')[9].split('?')[0];
				//Get the description
				itemDescription = data.media$group.media$description.$t;
				imgUrl=data.media$group.media$content[0].url;
				itemKind=kind;

				var newDiv =$('<div class="container"></div>').appendTo(nS.containerFolder);
				jQuery(newDiv).append('<div class="imgcont"><img class="image" src="'+itemThumbURL+'"></div>');
				if( kind == 'album' ) {
					jQuery(newDiv).append('<div class="labelFolder">'+itemTitle+'</div>');
					nS.itemInfo[i]=new Array(itemTitle, itemThumbURL, itemID, itemDescription,itemKind);
				}
				else {
					jQuery(newDiv).append('<div class="labelImage">'+itemTitle+'</div>');
					nS.itemInfo[i]=new Array(itemTitle, itemThumbURL, imgUrl, itemDescription,itemKind);
				}

				$(newDiv).hover(
					function() { jQuery(this).stop().animate({"borderBottomColor": "#888","borderTopColor": "#888","borderLeftColor": "#aaa","borderRightColor": "#888"}, "fast"); },
					function() { jQuery(this).stop().animate({"borderBottomColor": "#000","borderTopColor": "#000","borderLeftColor": "#000","borderRightColor": "#000"}, "fast"); }
				);

				jQuery(newDiv).data("index",i);
				newDiv.click(function() {
					var n=$(this).data("index");
					if( nS.itemInfo[n][4] == 'album' ) {
						//alert(nS.album_info[i][2]);
						nS.GetItems(nS.itemInfo[i][2],nS.itemInfo[i][0]);
					}
					else {
						var lstImages=new Array();
						lstImages[0]=nS.itemInfo[n][2];
						//alert(nS.itemInfo[n][2]);
						for( var j=n+1; j<nS.itemInfo.length; j++) {
							lstImages[lstImages.length]=nS.itemInfo[j][2];
						}
						for( var j=0; j<n; j++) {
							lstImages[lstImages.length]=nS.itemInfo[j][2];
						}
						$.fancybox.open(lstImages,{'autoPlay':false, 'nextEffect':'fade', 'prevEffect':'fade',
							helpers		: {	buttons	: { 'position' : 'bottom'} }
						});
					}
				});
			});
			jQuery(nS.containerFolder).find('.imgcont').css('width',nS.tW);
			jQuery(nS.containerFolder).find('.imgcont').css('height',nS.tH);
			jQuery(nS.containerFolder).find('img').css('maxWidth',nS.tW);
			jQuery(nS.containerFolder).find('img').css('maxHeight',nS.tH);

		});		
				
				
				
	}	

		

}